//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ZylNMEAGenerator"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  cmbLat->ItemIndex = 0;
  cmbLong->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnConnectClick(TObject *Sender)
{
  if (!ZylNMEAGenerator->Connect(efPort->Text))
    ShowMessage("Cannot connect.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnTransmitClick(TObject *Sender)
{
  if (ZylNMEAGenerator->GetSerialPort() != "")
    ZylNMEAGenerator->Transmit();
  else
    ShowMessage("You have to connect to a serial port.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnGenerateClick(TObject *Sender)
{
  ZylNMEAGenerator->Latitude_Degree = StrToInt(efLatDeg->Text);
  ZylNMEAGenerator->Latitude_Minute = StrToInt(efLatMin->Text);
  ZylNMEAGenerator->Latitude_Second = StrToFloat(efLatSec->Text);
  if (cmbLat->Text == "North")
    ZylNMEAGenerator->Latitude_Direction = cpNorth;
  else
    ZylNMEAGenerator->Latitude_Direction = cpSouth;
  ZylNMEAGenerator->Longitude_Degree = StrToInt(efLongDeg->Text);
  ZylNMEAGenerator->Longitude_Minute = StrToInt(efLongMin->Text);
  ZylNMEAGenerator->Longitude_Second = StrToFloat(efLongSec->Text);
  if (cmbLong->Text == "East")
    ZylNMEAGenerator->Longitude_Direction = cpEast;
  else
    ZylNMEAGenerator->Longitude_Direction = cpWest;
  ZylNMEAGenerator->Altitude = StrToFloat(efAltitude->Text);
  ZylNMEAGenerator->Heading = StrToFloat(efHeading->Text);
  ZylNMEAGenerator->Speed = ZylNMEAGenerator->KmhToKnots(StrToFloat(efSpeed->Text));

  Memo1->Lines->Text = ZylNMEAGenerator->GetNMEA();
}
//---------------------------------------------------------------------------
